package JElriDEV;

import java.awt.*;

    /**
     * internal class, used to store objects loaded from disk
     * also to redraw object when draw is called
     */
    class DrawableShape
    {
        Color  back,fore;
        int    items;
        public double  angle[];
        public double  length[];
        public boolean filled;
        int    xpoints[],ypoints[];
        boolean bShadeOn=false;

        public DrawableShape(boolean fill,Color fg,Color bg, int count, boolean shade)
        {
            filled = fill;
            back=bg;
            fore=fg;
            items=count;

            angle = new double[count];
            length = new double[count];

            xpoints = new int[count];
            ypoints = new int[count];
            bShadeOn=shade;
        }

        public void setPoints(int idx, double ang, double len)
        {
            if(idx<angle.length)
            {
                angle[idx]=ang;
                length[idx]=len;
            }
        }

      private Color shadeIt(Color c,double ang1,double ang2)
      {
        if(bShadeOn)
        {
          int r,g,b;
          r=Math.max(0,(int)((double)c.getRed()*(Math.sin(ang1)+Math.cos(ang2))));
          g=Math.max(0,(int)((double)c.getGreen()*(Math.sin(ang1)+Math.cos(ang2))));
          b=Math.max(0,(int)((double)c.getBlue()*(Math.sin(ang1)+Math.cos(ang2))));
          return new Color(Math.min(r,255),Math.min(g,255),Math.min(b,255));
        }
        else return c;
      }

    	public void Draw(Graphics gfx, double scale,Point centre,double rot_2d, double lenadjx,double lenadjy)
	    {
    		// correct values in loop
	    	for(int i=0;i<items;i++)
		    {
    			double len = length[i];
	    		double ang = angle[i];
		    	len *= scale;
			    ang += rot_2d;

      			xpoints[i] = (int)(Math.sin(ang)*(len*Math.sin(lenadjx)))+centre.x;
	    		ypoints[i] = (int)(-(Math.cos(ang)*(len*Math.cos(lenadjy))))+centre.y;
		    }

            if(filled)
            {
        		gfx.setColor(shadeIt(back,lenadjx,lenadjy));
	        	gfx.fillPolygon(xpoints,ypoints,items);
        		gfx.setColor(fore);
	        	gfx.drawPolyline(xpoints,ypoints,items);
            }
            else
            {
        		gfx.setColor(fore);
	        	gfx.drawPolyline(xpoints,ypoints,items);
            }
	    }
    }
